/* 
** universal menu for ggi
**
** H. Niemann 1997
**
** $Id:$
**
** $Log:$
**
*/

#ifndef _MENU_H
#define _MENU_H

#include <ggi/libggi.h>
#include "window.h"

#define MAXENTRIES 9
/* indexes 0 .. 8 but keys 1 ..9.
** any good solution for this??  
*/

struct menuentry {
	char * text ;        /* menu text to be printed */
	char * shortcut ;    /* Shortcut key(s) */
	int x;               /* printing position */
	int y;
};

struct menu {
	struct window w;
	 
	int lastentry ;                      /* number of last used entry */
	struct menuentry entry[MAXENTRIES] ;

	ggi_color entrycolor;

	ggi_color selectedcolor;
	ggi_color selectedbackgroundcolor;

	/* menu formatting. you should leave the defaults untouched. */
	int titleleftskip;       /* space left inner border <-> title */
	int titlerightskipmin;   /*       title <-> right inner border */
	int entryleftskip;       /**/
	int entryrightskipmin;

	int firstlineskip;
	int entrylineskip;
	int lastlineskip;

	char * toptext;
	int toptextx;
	int toptexty;
	ggi_color toptextcolor;

	char * bottomtext;
	int bottomtextx;
	int bottomtexty;
	ggi_color bottomtextcolor;

      

	int titlex, titley;    /* automatically calculated ! */

};

int default_menu(struct menu * m, struct ggi_visual * v);

int calculate_menu(struct menu * m);
/* calculates size and positions of elements */

int center_menu(struct menu * m);
/* moves menu to center of screen */

int do_menu(struct menu * m , int selected);


#endif
